#!/bin/sh

# dist.sh
# Create distribution packages of SHC. <- Use `make dist'!
# Miroslav Broz (miroslav.broz@email.cz)

VERSION="May 13th 2005"

FILE=shc
RPM=/usr/src/rpm	# this is for Debian >=3.0
#RPM=/usr/src/redhat	# this was RedHat 6.2 @ astrohk
#RPM=/usr/src/packages
DATE=`awk '/Version:/{print $2}' $FILE.spec`
RELEASE=`awk '/Release:/{print $2}' $FILE.spec`
#DATE=`date +"%y%m%d"`

targz() {
  cd ..
  rm -f $FILE-$DATE.tar.gz
  tar -vczf $FILE-$DATE.tar.gz $FILE-$DATE/
  cd $FILE-$DATE/
}

deb() {
  dpkg-buildpackage -rfakeroot
  rm -rf debian/shc
}

rpms() {
  cd ..
  cp $FILE-$DATE.tar.gz $RPM/SOURCES/
  cp $FILE-$DATE/$FILE.spec $RPM/SPECS/$FILE-$DATE.spec
  rpm -ba $RPM/SPECS/$FILE-$DATE.spec
  cp $RPM/SRPMS/$FILE-$DATE-$RELEASE.src.rpm .
  cp $RPM/RPMS/i386/$FILE-$DATE-$RELEASE.i386.rpm .
  cd $FILE-$DATE/
}

# manually create sfx ZIP in Windows OS
win() {
  cd windows/
  rm -f $FILE-*.zip $FILE.zip ../$FILE-*.win.zip
  zip -rp ../../$FILE-$DATE.win.zip *
  cd ..
}

case "$1" in
  targz)
    targz
  ;;
  deb)
    deb
  ;;
  rpm)
    rpms
  ;;
  win)
    win
  ;;
  --help)
    echo "Usage: dist.sh (targz|deb|rpm|win)"
  ;;
  --version)
    echo "Version: $VERSION"
  ;;
  "")
    targz
    deb
    rpms
    win
  ;;
  *)
    echo "Unknown command-line argument. Try \`dist.sh --help'"
esac

exit 0

